summaryrefslogtreecommitdiffhomepage
path: root/modules
diff options
context:
space:
mode:
Diffstat (limited to 'modules')
-rw-r--r--modules/admin-core/root/etc/config/luci_ethers0
-rw-r--r--modules/admin-core/root/etc/config/luci_hosts3
-rwxr-xr-xmodules/admin-core/root/etc/init.d/luci_ethers35
-rwxr-xr-xmodules/admin-core/root/etc/init.d/luci_fixtime11
-rwxr-xr-xmodules/admin-core/root/etc/init.d/luci_hosts34
-rwxr-xr-xmodules/admin-core/root/sbin/luci-flash89
6 files changed, 172 insertions, 0 deletions
diff --git a/modules/admin-core/root/etc/config/luci_ethers b/modules/admin-core/root/etc/config/luci_ethers
new file mode 100644
index 000000000..e69de29bb
--- /dev/null
+++ b/modules/admin-core/root/etc/config/luci_ethers
diff --git a/modules/admin-core/root/etc/config/luci_hosts b/modules/admin-core/root/etc/config/luci_hosts
new file mode 100644
index 000000000..6221df72d
--- /dev/null
+++ b/modules/admin-core/root/etc/config/luci_hosts
@@ -0,0 +1,3 @@
+config 'host'
+ option 'ipaddr' '10.11.12.13'
+ option 'hostname' 'sample-host'
diff --git a/modules/admin-core/root/etc/init.d/luci_ethers b/modules/admin-core/root/etc/init.d/luci_ethers
new file mode 100755
index 000000000..8cf46729d
--- /dev/null
+++ b/modules/admin-core/root/etc/init.d/luci_ethers
@@ -0,0 +1,35 @@
+#!/bin/sh /etc/rc.common
+START=59
+
+apply_lease() {
+ local cfg="$1"
+
+ config_get macaddr "$cfg" macaddr
+ config_get ipaddr "$cfg" ipaddr
+
+ [ -n "$macaddr" -a -n "$ipaddr" ] || return 0
+
+ echo "$macaddr $ipaddr" >> /var/etc/ethers
+}
+
+start() {
+ if [ ! -L /etc/ethers ]; then
+ test -f /etc/ethers && mv /etc/ethers /etc/ethers.local
+ ln -s /var/etc/ethers /etc/ethers
+ fi
+
+ test -d /var/etc || mkdir -p /var/etc
+
+ config_load luci_ethers
+ config_foreach apply_lease static_lease
+
+ test -f /etc/ethers.local && cat /etc/ethers.local >> /var/etc/ethers
+
+ return 0
+}
+
+stop() {
+ test -f /var/etc/ethers && rm -f /var/etc/ethers
+
+ return 0
+}
diff --git a/modules/admin-core/root/etc/init.d/luci_fixtime b/modules/admin-core/root/etc/init.d/luci_fixtime
new file mode 100755
index 000000000..681d9d789
--- /dev/null
+++ b/modules/admin-core/root/etc/init.d/luci_fixtime
@@ -0,0 +1,11 @@
+#!/bin/sh /etc/rc.common
+
+START=05
+
+start() {
+ cat <<' EOF' | lua -l luci.fs -l luci.util -
+ if (os.time() < 1000000000) then
+ os.execute('date -s ' .. os.date('%m%d%H%M%Y', luci.fs.mtime(luci.util.libpath())))
+ end
+ EOF
+}
diff --git a/modules/admin-core/root/etc/init.d/luci_hosts b/modules/admin-core/root/etc/init.d/luci_hosts
new file mode 100755
index 000000000..d01bfbbd5
--- /dev/null
+++ b/modules/admin-core/root/etc/init.d/luci_hosts
@@ -0,0 +1,34 @@
+#!/bin/sh /etc/rc.common
+START=60
+
+apply_host() {
+ local cfg="$1"
+
+ config_get hostname "$cfg" hostname
+ config_get ipaddr "$cfg" ipaddr
+
+ [ -n "$hostname" -a -n "$ipaddr" ] || return 0
+
+ echo "$ipaddr $hostname" >> /var/etc/hosts
+}
+
+start() {
+ if [ ! -L /etc/hosts ]; then
+ test -f /etc/hosts && mv /etc/hosts /etc/hosts.local
+ ln -s /var/etc/hosts /etc/hosts
+ fi
+
+ test -d /var/etc || mkdir -p /var/etc
+ test -f /etc/hosts.local && cat /etc/hosts.local >> /var/etc/hosts
+
+ config_load luci_hosts
+ config_foreach apply_host host
+
+ return 0
+}
+
+stop() {
+ test -f /var/etc/hosts && rm -f /var/etc/hosts
+
+ return 0
+}
diff --git a/modules/admin-core/root/sbin/luci-flash b/modules/admin-core/root/sbin/luci-flash
new file mode 100755
index 000000000..819be40b5
--- /dev/null
+++ b/modules/admin-core/root/sbin/luci-flash
@@ -0,0 +1,89 @@
+#!/bin/sh
+. /etc/functions.sh
+
+# initialize defaults
+RAMFS_COPY_BIN="/usr/bin/awk" # extra programs for temporary ramfs root
+RAMFS_COPY_DATA="" # extra data files
+export KEEP_PATTERN=""
+export VERBOSE=0
+
+# parse options
+while [ -n "$1" ]; do
+ case "$1" in
+ -k)
+ shift
+ export SAVE_CONFIG=1
+ export KEEP_PATTERN="$1"
+ ;;
+ -*)
+ echo "Invalid option: $1"
+ exit 1
+ ;;
+ *) break;;
+ esac
+ shift;
+done
+
+export CONFFILES=/tmp/sysupgrade.conffiles
+export CONF_TAR=/tmp/sysupgrade.tgz
+
+[ -f $CONFFILES ] && rm $CONFFILES
+[ -f $CONF_TAR ] && rm $CONF_TAR
+
+export ARGV="$*"
+export ARGC="$#"
+
+[ -z "$ARGV" ] && {
+ cat <<EOF
+Usage: $0 [options] <image file or URL>
+
+Options:
+ -k <"file 1, file 2, ..."> Files to be kept
+EOF
+ exit 1
+}
+
+add_pattern_conffiles() {
+ local file="$1"
+ find $KEEP_PATTERN >> "$file" 2>/dev/null
+ return 0
+}
+
+# hooks
+sysupgrade_image_check="platform_check_image"
+sysupgrade_init_conffiles=""
+
+[ -n "$KEEP_PATTERN" ] && append sysupgrade_init_conffiles "add_pattern_conffiles"
+
+include /lib/upgrade
+
+do_save_conffiles() {
+ [ -z "$(rootfs_type)" ] && {
+ echo "Cannot save config while running from ramdisk."
+ exit 3
+ return 0
+ }
+ run_hooks "$CONFFILES" $sysupgrade_init_conffiles
+
+ v "Saving config files..."
+ [ "$VERBOSE" -gt 1 ] && TAR_V="v" || TAR_V=""
+ tar c${TAR_V}zf "$CONF_TAR" -T "$CONFFILES" 2>/dev/null
+}
+
+type platform_check_image >/dev/null 2>/dev/null || {
+ echo "Firmware upgrade is not implemented for this platform."
+ exit 1
+}
+
+for check in $sysupgrade_image_check; do
+ ( eval "$check \"\$ARGV\"" ) || {
+ echo "Image check '$check' failed."
+ exit 2
+ }
+done
+
+[ -n "$sysupgrade_init_conffiles" ] && do_save_conffiles
+run_hooks "" $sysupgrade_pre_upgrade
+
+v "Switching to ramdisk..."
+run_ramfs '. /etc/functions.sh; include /lib/upgrade; do_upgrade'